      subroutine avevar (mcangs, chnst, ave, sd)                        AVEV001
c                                                                       AVEV002
      include 'brkcln.par'                                              AVEV003
c                                                                       AVEV004
      real    mcangs(nmnang,maxres), ave, sd, var, s                    AVEV005
c                                                                       AVEV006
      integer j, n, chnst                                               AVEV007
c                                                                       AVEV008
      logical xney                                                      AVEV009
c                                                                       AVEV010
      ave = 0.0                                                         AVEV011
      sd  = 0.0                                                         AVEV012
      var = 0.0                                                         AVEV013
      n   = 0                                                           AVEV014
      do 11 j = 1, chnst                                                AVEV015
      if (xney(mcangs(1,j),null)) then                                  AVEV016
         ave = ave + mcangs(1,j)                                        AVEV017
         n = n + 1                                                      AVEV018
      end if                                                            AVEV019
   11 continue                                                          AVEV020
      if (n .gt. 0) then                                                AVEV021
         ave = ave / real(n)                                            AVEV022
      else                                                              AVEV023
         ave = 0.0                                                      AVEV024
      end if                                                            AVEV025
      do 12 j = 1, chnst                                                AVEV026
      if (xney(mcangs(1,j),null)) then                                  AVEV027
         s = mcangs(1,j) - ave                                          AVEV028
         var = var + (s*s)                                              AVEV029
      end if                                                            AVEV030
   12 continue                                                          AVEV031
      if (n .gt. 1) then                                                AVEV032
         var = var / real(n-1)                                          AVEV033
         sd = sqrt(var)                                                 AVEV034
      else                                                              AVEV035
         var = 0.0                                                      AVEV036
         sd = 0.0                                                       AVEV037
      end if                                                            AVEV038
      end                                                               AVEV039
